//---------------------------------------------------------------------------

#include <System.hpp>
#pragma hdrstop

#include "uDosCmd.h"
#include "TLHelp32.h"

#pragma package(smart_init)
//---------------------------------------------------------------------------
//
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(&UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TThreadAsynTimer::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//
//---------------------------------------------------------------------------
int __fastcall fnGetPID(const String aExeName);
bool __fastcall fnKillPID(int aPID);
bool __fastcall fnKillExe(const String aExeName);
bool __fastcall fnAdjustProcessPrivilege(HANDLE ProcessHandle, String TokenName);
bool __fastcall fnCreateProcess(const String aCmLine);
//---------------------------------------------------------------------------
bool __fastcall fnAdjustProcessPrivilege(HANDLE ProcessHandle, String TokenName)
{
  bool Result = false;
  HANDLE hToken;
  TOKEN_PRIVILEGES TokenPri;
  LUID Luid;
  DWORD Len;

  if (OpenProcessToken(ProcessHandle, TOKEN_ADJUST_PRIVILEGES, &hToken) == true) {
    if (LookupPrivilegeValue(NULL, TokenName.c_str(), &Luid) == true) {
      TokenPri.PrivilegeCount = 1;
      TokenPri.Privileges[0].Luid = Luid;
      TokenPri.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

      AdjustTokenPrivileges(hToken, false, &TokenPri, sizeof(TOKEN_PRIVILEGES), NULL, &Len);
      if (GetLastError() == ERROR_SUCCESS) {
        Result = true;
      }
    }
  }
  return Result;
}
//---------------------------------------------------------------------------
int __fastcall fnGetPID(const String aExeName)
{
  int Result = -1;
  bool Loop;
  String ExeName;
  HANDLE SnapshotHandle;
  PROCESSENTRY32 ProcessEntry32;
  SnapshotHandle = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  ProcessEntry32.dwSize = sizeof(ProcessEntry32);

  Loop = Process32First(SnapshotHandle, &ProcessEntry32);
  while (Loop == true) {
    ExeName = ExtractFileName(ProcessEntry32.szExeFile);
    if (UpperCase(ExeName) == UpperCase(aExeName) ) {
      Result= (int)ProcessEntry32.th32ProcessID;
      break;
    }
    Loop = Process32Next(SnapshotHandle, &ProcessEntry32);
  };
  CloseHandle(SnapshotHandle);
  return Result;
}
//---------------------------------------------------------------------------
bool __fastcall fnKillPID(int aPID)
{
  bool Result = false;
  HANDLE hProc;

  if (fnAdjustProcessPrivilege(GetCurrentProcess(), "SeDebugPrivilege") == true) {
    hProc = OpenProcess(PROCESS_ALL_ACCESS, false, DWORD(aPID));
    if (hProc != NULL) {
      Result = TerminateProcess(hProc, 0);
      CloseHandle(hProc);
    }
  }
  return Result;
}
//---------------------------------------------------------------------------
bool __fastcall fnKillExe(const String aExeName)
{
  return fnKillPID(fnGetPID(aExeName));
}
//---------------------------------------------------------------------------
bool __fastcall fnCreateProcess(const String aCmLine)
{
  //  aCmLine = L"\\..\\Debug\\another.exe a b c d"
  bool Result;
  STARTUPINFO si;
  PROCESS_INFORMATION pi;
  ZeroMemory(&si, sizeof(si));
  ZeroMemory(&pi, sizeof(pi));
  // CREATE_NEW_CONSOLE, sx}li{
  // CREATE_SUSPENDED, li{Ыث᱾_AեResumeThread
  DWORD CreationFlags = 0;

  Result = CreateProcess(NULL, // V@NULLBΨӫwiҶer`rŦ
                         aCmLine.c_str(), // ROrŦ
                         NULL, // V@SECURITY_ATTRIBUTEScAoӵcMwO_^y`iHQli{~ӡC
                         NULL, // pGlpProcessAttributesѼƬš]NULL^Ay`Q~ӡC<PW>
                         false, // ܷsi{O_qեζi{B~ӤFy`C
                         CreationFlags, // w[BΨӱuMi{Ыت
                         NULL, // V@ӷsi{ҶCpGѼƬšAsi{ϥνեζi{
                         NULL, // wli{u@|
                         &si, // Mwsi{DpܪSTARTUPINFOc
                         &pi); // si{ѧOHPROCESS_INFORMATIONc

  if (Result == true) {
     // Uy`AѰi{Msi{YA
     // Miणp߽եTerminateProcessli{
    CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);
  }
  return Result;
}
//---------------------------------------------------------------------------
__fastcall TDosCmd::TDosCmd(String aCmdLine)
  : TThread(true)
{
  m_CmdLine = aCmdLine;
  // Busy loop }
  m_bBusyTerminate = false;
  // PB flage
  m_SynMode = 0;
  // timer enable
  m_Enabled = true;
  //
  // Automatically delete while terminating.
  // 1. true: ݭn() delete thread object
  //    귽 uݭn Is Terminate(),
  //    }, Execute(}), OnTerminate, ~destructor
  //    `N: boؽЪpU A WaitFor() hݸ귽
  //    M|iûݪ(] WaitFor() }ɾ(Execute(})..),
  //    wgLF)
  //
  // 2. false: 귽ݭn delete thread object
  //    delete  method QIsǬ
  //    ~destructor, Execute(}), OnTerminate
  this->FreeOnTerminate = false;
  // wait Event
  m_hWaitEvent = fnCreateEvent(false, // false = ۰ʭm; true = ʭm
                               false, // false = Eventl,DEoA; true = Eventl,EoA
                               fnGetEventName()); // EventW
  m_Interval = 16;
  //
  m_hReadStdOut = NULL;
  m_hNewStdOut = NULL;
  m_hWriteStdIn = NULL;
  m_hNewStdIn = NULL;
  m_ReadOutEvent = NULL;
  m_ProcessTerminateEvent = NULL;
  m_ExceptionEvent = NULL;
  m_slCmd = new TStringList();
  m_slReadOut = new TStringList();
  m_cs = new TCriticalSection();
  m_ErrorCode = 0;
}
//---------------------------------------------------------------------------
__fastcall TDosCmd::~TDosCmd()
{
  if (this->Suspended) {
    this->Start();
  }
  // trigger }:
  this->Terminate();
  // trigger event
  SetEvent(m_hWaitEvent);
  m_bBusyTerminate = true;
  // wait for }:
  // 1.  Execute() }.
  // 2. pG Assign OnTerminateƥ, n OnTerminateƥ󧹦.
  // 3. WaitFor ^ǭ, O SetReturnValue(int)
  this->WaitFor();
  // release ...
  CloseHandle(m_hWaitEvent);
  if (m_pi.hProcess != NULL) {
    if (m_ProcessAlive == true) {
      TerminateProcess(m_pi.hProcess, 0);
    }
    CloseHandle(m_pi.hProcess);
  }
  if (m_pi.hThread != NULL) {
    CloseHandle(m_pi.hThread);
  }
  if (m_hReadStdOut != NULL) {
    CloseHandle(m_hReadStdOut);
  }
  if (m_hNewStdOut != NULL) {
    CloseHandle(m_hNewStdOut);
  }
  if (m_hWriteStdIn != NULL) {
    CloseHandle(m_hWriteStdIn);
  }
  if (m_hNewStdIn != NULL) {
    CloseHandle(m_hNewStdIn);
  }
  delete m_slCmd;
  delete m_slReadOut;
  delete m_cs;
}
//---------------------------------------------------------------------------
void __fastcall TDosCmd::SetEnabled(bool b)
{
  m_Enabled = b;
  if (m_Enabled == true) {
    SetEvent(m_hWaitEvent);
  }
}
//---------------------------------------------------------------------------
void __fastcall TDosCmd::Done()
{
  if (m_slReadOut->Count != 0) {
    if (m_ReadOutEvent != NULL) {
      m_ReadOutEvent(this, m_slReadOut->Strings[0]);
    }
    m_slReadOut->Delete(0);
  }

  if (m_ErrorCode != 0) {
    if (m_ExceptionEvent != NULL) {
      m_ExceptionEvent(this, fnGetErrorCodeMsg(m_ErrorCode));
      m_ExceptionEvent = NULL;
    }
  }

  if (m_ProcessAlive == false) {
    if (m_ProcessTerminateEvent != NULL) {
      m_ProcessTerminateEvent(this, Format("DosCmd: %s Terminate", ARRAYOFCONST((ExtractFileName(m_CmdLine)))));
      m_ProcessTerminateEvent = NULL;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TDosCmd::UpdataSynMode()
{
  switch (m_SynMode ) {
  case 2: this->Queue(Done); break;
  case 3: this->Synchronize(Done); break;
  default: Done();
  }
}
//---------------------------------------------------------------------------
DWORD __fastcall TDosCmd::WaitForEvent()
{
  DWORD Result;
  if (m_Enabled == true) {
    Result = WaitForSingleObject(m_hWaitEvent, (DWORD)m_Interval);
  }
  else {
    Result = WaitForSingleObject(m_hWaitEvent, INFINITE);
  }

  if (this->Terminated) {
    Result = WAIT_ABANDONED;
  }
  return Result;
}
//---------------------------------------------------------------------------
void __fastcall TDosCmd::Do()
{
  String Result;
  AnsiString WriteStr;
  DWORD ReceiveLen, ReadLen, Exit_Code, SendLen, WriteLen;
  const int MaxLen = 4*1024;
  char Buffer[MaxLen] = {0};

  if (WaitForEvent() == WAIT_TIMEOUT) {
    //while the process is running
    if (GetExitCodeProcess(m_pi.hProcess, &Exit_Code) == true) {
      if (PeekNamedPipe(m_hReadStdOut, Buffer, MaxLen, &ReceiveLen, 0, 0) == true) {
        if (ReceiveLen != 0) {
          // read data from pipe
          if (ReadFile(m_hReadStdOut, Buffer, ReceiveLen, &ReadLen, NULL) == true) {
            m_slReadOut->Add(String(AnsiString(Buffer)));
          }
          else {
            m_ErrorCode = GetLastError();
          }
        }
        else {
          // write data to pipe
          if (m_cs->TryEnter() == true) {
            if (m_slCmd->Count != 0) {
              WriteStr = m_slCmd->Strings[0];
              SendLen = WriteStr.Length();
              memcpy(Buffer, WriteStr.c_str(), SendLen);
              if (WriteFile(m_hWriteStdIn, Buffer, SendLen, &WriteLen, 0) == true) {
                m_slCmd->Delete(0);
              }
              else {
                m_ErrorCode = GetLastError();
              }
            }
            m_cs->Leave();
          }
        }
      }
      else {
        m_ErrorCode = GetLastError();
      }
    }
    else {
      m_ErrorCode = GetLastError();
    }
    // check process is alive
    if (Exit_Code != STILL_ACTIVE) {
      m_ProcessAlive = false;
    }
  }
  else{
  // TODO:
  }
}
//---------------------------------------------------------------------------
void __fastcall TDosCmd::AddCmd(String aCmd)
{
  //add CR/LF at the end of line
  String Cmd = aCmd + L"\r\n";

  m_cs->Enter();
  if (m_slCmd->IndexOf(Cmd) == -1) {
    m_slCmd->Add(Cmd);
  }
  m_cs->Leave();
}
//---------------------------------------------------------------------------
DWORD __fastcall TDosCmd::NewStdInPipe()
{
  m_sa.nLength = sizeof(m_sa);
  m_sa.lpSecurityDescriptor = 0;
  m_sa.bInheritHandle = true;
  if (CreatePipe(&m_hNewStdIn, &m_hWriteStdIn, &m_sa, 0) == true) {
    return 0;
  }
  else {
    return GetLastError();
  }
}
//---------------------------------------------------------------------------
DWORD __fastcall TDosCmd::NewStdOutPipe()
{
  m_sa.nLength = sizeof(m_sa);
  m_sa.lpSecurityDescriptor = 0;
  m_sa.bInheritHandle = true;
  if (CreatePipe(&m_hReadStdOut, &m_hNewStdOut, &m_sa, 0) == true) {
    return 0;
  }
  else {
    return GetLastError();
  }
}
//---------------------------------------------------------------------------
DWORD __fastcall TDosCmd::NewProcess()
{
  DWORD Code;
  m_ProcessAlive = false;
  Code = NewStdInPipe();
  if (Code != 0) {return Code;}
  Code = NewStdOutPipe();
  if (Code != 0) {return Code;}

  ZeroMemory(&m_si, sizeof(m_si));
  ZeroMemory(&m_pi, sizeof(m_pi));
  m_si.cb = sizeof(STARTUPINFO);
  m_si.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
  m_si.hStdOutput = m_hNewStdOut;
  m_si.hStdError = m_hNewStdOut;
  m_si.hStdInput = m_hNewStdIn;
  m_si.wShowWindow = SW_HIDE;
  // CREATE_NEW_CONSOLE, sx}li{
  // CREATE_SUSPENDED, li{Ыث᱾_AեResumeThread
  DWORD CreationFlags = CREATE_NEW_CONSOLE | NORMAL_PRIORITY_CLASS;

  bool b = CreateProcess(NULL, // V@NULLBΨӫwiҶer`rŦ
                         m_CmdLine.c_str(), // ROrŦ
                         NULL, // V@SECURITY_ATTRIBUTEScAoӵcMwO_^y`iHQli{~ӡC
                         NULL, // pGlpProcessAttributesѼƬš]NULL^Ay`Q~ӡC<PW>
                         true, // ܷsi{O_qեζi{B~ӤFy`C
                         CreationFlags, // w[BΨӱuMi{Ыت
                         NULL, // V@ӷsi{ҶCpGѼƬšAsi{ϥνեζi{
                         NULL, // wli{u@|
                         &m_si, // Mwsi{DpܪSTARTUPINFOc
                         &m_pi); // si{ѧOHPROCESS_INFORMATIONc
  if (b == true) {
    m_ProcessAlive = true;
    return 0;
  }
  else {
    return GetLastError();
  }
}
//---------------------------------------------------------------------------
void __fastcall TDosCmd::Execute()
{
  // wait for return value
  this->SetReturnValue(777);
  m_ErrorCode = NewProcess();
  do {
    if (m_ErrorCode == 0 && m_ProcessAlive == true) {
      Do();
    }
    // thread syn mode
    UpdataSynMode();
  } while (this->Terminated == false && m_bBusyTerminate == false);
}
//---------------------------------------------------------------------------
