//---------------------------------------------------------------------------

#ifndef uDosCmdH
#define uDosCmdH
//---------------------------------------------------------------------------
#include "uUtilize.h"
#include <System.SyncObjs.hpp>
#include <System.Classes.hpp>
//---------------------------------------------------------------------------
typedef void __fastcall (__closure *TDosCmdEvent)(TObject* Sender, String aStr);

class TDosCmd : public TThread
{
private:
  SECURITY_ATTRIBUTES m_sa;
  STARTUPINFO m_si;
  PROCESS_INFORMATION m_pi;
  HANDLE m_hWaitEvent;
  HANDLE m_hReadStdOut, m_hNewStdOut;
  HANDLE m_hWriteStdIn, m_hNewStdIn;
  TDosCmdEvent m_ReadOutEvent, m_ProcessTerminateEvent, m_ExceptionEvent;
  TCriticalSection *m_cs;
  TStringList *m_slCmd, *m_slReadOut;
  int m_SynMode;
  DWORD m_ErrorCode;
  bool m_bBusyTerminate, m_Enabled, m_ProcessAlive;
  unsigned m_Interval;
  String m_CmdLine;
  void __fastcall SetEnabled(bool b);
  DWORD __fastcall NewStdInPipe();
  DWORD __fastcall NewStdOutPipe();
  DWORD __fastcall NewProcess();

protected:
  void __fastcall Execute();
  void __fastcall Done();
  void __fastcall Do();
  void __fastcall UpdataSynMode();
  DWORD __fastcall WaitForEvent();

public:
  __fastcall TDosCmd(String aCmdLine);
  __fastcall ~TDosCmd();
  void __fastcall AddCmd(String aCmd);
  __property bool Enabled={read=m_Enabled, write=SetEnabled};
  __property bool ProcessAlive={read=m_ProcessAlive};
  __property unsigned Interval={read=m_Interval, write=m_Interval};
  __property int SynMode={read=m_SynMode, write=m_SynMode};
  __property TDosCmdEvent ReadOutEvent={read=m_ReadOutEvent, write=m_ReadOutEvent, default=NULL};
  __property TDosCmdEvent ExceptionEvent={read=m_ExceptionEvent, write=m_ExceptionEvent, default=NULL};
  __property TDosCmdEvent ProcessTerminateEvent={read=m_ProcessTerminateEvent, write=m_ProcessTerminateEvent, default=NULL};
};
//---------------------------------------------------------------------------
extern int __fastcall fnGetPID(const String aExeName);
extern bool __fastcall fnKillPID(int aPID);
extern bool __fastcall fnKillExe(const String aExeName);
extern bool __fastcall fnAdjustProcessPrivilege(HANDLE ProcessHandle, String TokenName);
extern bool __fastcall fnCreateProcess(const String aCmLine);

#endif
