//---------------------------------------------------------------------------

#pragma hdrstop

#include "uStopWatch.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall TStopwatchElp::TStopwatchElp()
{
  // crete TStopwatch record and start running
  m_sw = TStopwatch::StartNew();
  // cumulation time; unit: ms
  m_Cumulation = m_sw.ElapsedMilliseconds;
}
//----------------------------------------------------------------------------
void __fastcall TStopwatchElp::Reset()
{
  m_sw.Reset();
  m_sw.Start();
  m_Cumulation = m_sw.ElapsedMilliseconds;
}
//----------------------------------------------------------------------------
__int64 __fastcall TStopwatchElp::Cumulation()
{
// unit: ms
  return m_sw.ElapsedMilliseconds;
}
//----------------------------------------------------------------------------
__int64 __fastcall TStopwatchElp::Span()
{
// unit: ms
  __int64 Result;
  Result = m_sw.ElapsedMilliseconds - m_Cumulation;
  m_Cumulation = m_sw.ElapsedMilliseconds;
  return Result;
}
//----------------------------------------------------------------------------
TDateTime __fastcall TStopwatchElp::SpanTime()
{
  TDateTime Result;
  Result = EncodeTime(0, 0, 0, 1); // 1 millisecond
  Result.Val = Result.Val*Span();
  return Result;
}
//----------------------------------------------------------------------------
TDateTime __fastcall TStopwatchElp::CumulationTime()
{
  TDateTime Result;
  Result = EncodeTime(0, 0, 0, 1); // 1 millisecond
  Result.Val = Result.Val*Cumulation();
  return Result;
}
//----------------------------------------------------------------------------
String __fastcall TStopwatchElp::SpanStr()
{
  return FormatDateTime(L"s.zzz", SpanTime());
}
//----------------------------------------------------------------------------
String __fastcall TStopwatchElp::CumulationStr()
{
  return FormatDateTime(L"s.zzz", CumulationTime());
}
//----------------------------------------------------------------------------