//---------------------------------------------------------------------------

#pragma hdrstop

#include "uUtilize.h"


#include <IdHashMessageDigest.hpp>
#include <inifiles.hpp>
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
int __fastcall fnGetObjSN(TObject *Sender);
String __fastcall fnGetEventName();
HANDLE __fastcall fnCreateEvent(bool bManualReset, bool bInitState, String Name);
String __fastcall fnGetGUID();
String __fastcall fnGetFileVersion(String FileName);
String __fastcall fnGetExeFileName();
String __fastcall fnGetExeName();
String __fastcall fnGetExeVS();
String __fastcall fnGetErrorCodeMsg(DWORD ErrorCode);
String __fastcall fnGetExecuteIniFileName();
bool __fastcall fnExecuteIniFileExist();
String __fastcall fnReadIniString(String aFile, String aSect, String aIdent);
TMemIniFile *__fastcall fnNewIni(String aFile);
String __fastcall fnReadIniSect(String aFile, String aSect);
TStringList * __fastcall fnNewListForIniSect(String aFile, String aSect);
TStringList * __fastcall fnNewListForIniValue(String aFile, String aSect);
//---------------------------------------------------------------------------
int __fastcall fnGetObjSN(TObject *Sender)
{
  int cnlen, onlen;
  TComponent *cmp = dynamic_cast<TComponent*>(Sender);
  if (cmp != NULL) {
    cnlen = cmp->ClassName().Length();
    onlen = cmp->Name.Length();
    return cmp->Name.SubString(cnlen, onlen - cnlen + 1).ToIntDef(-1);
  }
  else {
    return -1;
  }
}
//---------------------------------------------------------------------------
String __fastcall fnGetGUID()
{
  GUID Guid;
  CreateGUID(Guid);
  return GUIDToString(Guid);
}
//---------------------------------------------------------------------------
String __fastcall fnGetEventName()
{
  return Format("Event_%s", ARRAYOFCONST((fnGetGUID())));
}
//---------------------------------------------------------------------------
HANDLE __fastcall fnCreateEvent(bool bManualReset, bool bInitState, String Name)
{
  HANDLE Result;
  Result = CreateEvent(NULL, // w@ NULLܨϥιw]
                       bManualReset, // false = ۰ʭm; true = ʭm
                       bInitState, // false = Eventl DEoA; true = Eventl EoA
                       Name.c_str()); // EventW
  return Result;
}
//---------------------------------------------------------------------------
String __fastcall fnGetFileVersion(String FileName)
{
  String Result;
  wchar_t *pBuf;
  VS_FIXEDFILEINFO *pVsInfo;
  unsigned int FileInfoSize = sizeof(VS_FIXEDFILEINFO);
  int VerInfoSize = GetFileVersionInfoSize(FileName.w_str(), NULL);

  if (VerInfoSize != 0) {
    pBuf = new wchar_t[VerInfoSize];
    if (GetFileVersionInfo(FileName.c_str(), 0, VerInfoSize, pBuf)) {
      if (VerQueryValue(pBuf, L"\\", (void**)&pVsInfo, &FileInfoSize)) {
        Result = Format("V%d.%d.%d Build%d",
                        ARRAYOFCONST(((HIWORD(pVsInfo->dwFileVersionMS)),
                                      (LOWORD(pVsInfo->dwFileVersionMS)),
                                      (HIWORD(pVsInfo->dwFileVersionLS)),
                                      (LOWORD(pVsInfo->dwFileVersionLS)))));
      }
    }
    delete [] pBuf;
  }
  return Result;
}
//-----------------------------------------------------------------------------
String __fastcall fnGetErrorCodeMsg(DWORD ErrorCode)
{
  String Result;
  LPVOID lpMsgBuf;
  FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
                NULL,
                ErrorCode,
                MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
                (wchar_t *)&lpMsgBuf,
                0,
                NULL);

  Result = Format("%s", ARRAYOFCONST(((wchar_t *)lpMsgBuf)));
  LocalFree(lpMsgBuf);
  return Result;
}
//-----------------------------------------------------------------------------------
String __fastcall fnGetExeFileName()
{
  return ExpandFileName(ParamStr(0));
}
//-----------------------------------------------------------------------------
String __fastcall fnGetExeName()
{
  return ExtractFileName(ChangeFileExt(fnGetExeFileName(), ""));
}
//-----------------------------------------------------------------------------
String __fastcall fnGetExeVS()
{
  return fnGetExeName() + " " + fnGetFileVersion(fnGetExeFileName());
}
//-----------------------------------------------------------------------------
String __fastcall fnGetExecuteIniFileName()
{
  return ChangeFileExt(fnGetExeFileName(), ".ini");
}
//---------------------------------------------------------------------------
bool __fastcall fnExecuteIniFileExist()
{
  return FileExists(fnGetExecuteIniFileName());
}
//---------------------------------------------------------------------------
TMemIniFile *__fastcall fnNewIni(String aFile)
{
  TMemIniFile *Result;
  if (FileExists(aFile)) {
    Result = new TMemIniFile(aFile);
  }
  else {
    Result = NULL;
  }
  return Result;
}
//---------------------------------------------------------------------------
String __fastcall fnReadIniString(String aFile, String aSect, String aIdent)
{
// return "Value1,Value2"
//
//  [Sect]
//  xxx=Value1
//  yyy=Value2

  String Result;
  TMemIniFile *ini = fnNewIni(aFile);
  if (ini != NULL) {
    Result = ini->ReadString(aSect, aIdent, "");
    delete ini;
  }
  return Result;
}
//---------------------------------------------------------------------------
TStringList * __fastcall fnNewListForIniSect(String aFile, String aSect)
{
// return "Ident1,Ident2"
//
//  [Sect]
//  Ident1=xxx
//  Ident2=yyy

  TStringList *Result;
  TMemIniFile *ini = fnNewIni(aFile);
  if (ini != NULL) {
    Result = new TStringList;
    ini->ReadSection(aSect, Result);
    delete ini;
  }
  else {
    Result = NULL;
  }
  return Result;
}
//---------------------------------------------------------------------------
TStringList * __fastcall fnNewListForIniValue(String aFile, String aSect)
{
// return "Ident1=Value1,Ident1=Value2"
//
// [Sect]
// Ident1=Value1
// Ident2=Value2

  TStringList *Result;
  TMemIniFile *ini = fnNewIni(aFile);
  if (ini != NULL) {
    Result = new TStringList;
    ini->ReadSectionValues(aSect, Result);
    delete ini;
  }
  else {
    Result = NULL;
  }
  return Result;
}
//---------------------------------------------------------------------------







